
ARGccoff        EQU     word ptr [bp+4] ; (DS:) offset
ARGy            EQU     word ptr [bp+6] ; row
ARGcol          EQU     word ptr [bp+8] ; start color
ARGiscol        EQU     word ptr [bp+10] ; color it?

;VARshift        EQU              [bp-2]
;VARxoff         EQU              [bp-4]
;VARyoff         EQU              [bp-6]
;VARoff          EQU              [bp-8]

;BytesPerLine    =       80              ; (must 40 in 320x200 16-color mode)
;RMWbits         =       18h             ; Read-Modify-Write bits

_TEXT           SEGMENT byte public 'CODE'
                ASSUME  cs:_TEXT

                PUBLIC  _colputline

                   ; 30 31 32 33 34 35 36 37 38 39
colxcod         DB    0, 4, 2, 6, 1, 5, 3, 7, 0, 0
                DB    8,12,10,14, 9,13,11,15, 0, 0
ans_hilo        DB    ?    ; ANSI hi/lo status
ans_colo        DB    ?    ; ANSI lastcol/nohis status
add_fix		DB    ?
;----------------------------------------------------
fromhex         proc near
                cmp al,'0'
                jb  badret
                cmp al,'9'
                ja  letter
                sub al,'0'
                ret
letter:         cmp     al,'F'
                ja      badret
                cmp     al,'A'
                jb      badret
                sub     al,'A'
                add     al,10
                ret
badret:         mov al,0ffh
                ret
fromhex         endp

;----------------------------------------------------

_colputline     PROC    near

                push    bp              ;; preserve caller registers
                mov     bp,sp
                sub     sp,10           ; stack space for local variable
                push    si              ;;
                push    di              ;;
                push    ds              ;;

; Main code +-------------------------------------
                mov 	ans_hilo,0
                mov 	ans_colo,7
                mov     ax,ARGy
                xor     ah,ah
                mov     bl,160
                mul     bl
                mov     bx,0 ; ARGx volt, de inkabb 0 most
                shl     bx,1
                add     ax,bx
                mov     di,ax   ; dest : ES:DI
                mov     ax,0B800h
                mov     es,ax
                mov     ax,ARGccoff
                mov     si,ax   ; source: DS:SI
                mov     dx,ARGcol
                xor     dh,dh       ; DL: color
                mov     ax,ARGiscol
                mov     dh,al  ; al a col-flag (0-color, 1-ne! interpret)

                cld
                mov     cx,80
ujxx:           lodsb
                cmp     al,0
                je      kiinnenr
                cmp     cx,0
                je      kiinnenr
                cmp     al,'@'
                jne     nocol1
                ;---------------------
                lodsb
                cmp     al,'X'
                je      okcol1
                mov     al,'@'
                dec     si
                jmp     nocol1

kiinnenr:       jmp kiinnen

okcol1:         lodsb           ; itt meg ell. kell a kozbeni '\0'-t, stb.
                call    fromhex  ; AL
                cmp     al,0ffh
                je      rossz2
                mov     bl,al
                shl     bl,4

                lodsb
                call    fromhex ; AL
                cmp     al,0ffh
                je      rossz1
                add     bl,al

                cmp     dh,0
                jne     ujxx  ; ha flag-col volt, akkor nincs szinvaltas!

                mov     dl,bl

                jmp     ujxx

rossz2:         dec     si
rossz1:         sub     si,2
                lodsb
                ;------------------------
nocol1:
                cmp     al,27 ; ESC/ANSI code
                je	ans_kod
                jmp     nocol2
ans_kod:
                ;-------------------------ANSI     ; pl. ESC[11C - 11 space
                mov	add_fix,0                  ; nincs implementalva!
                lodsb
                cmp     al,'['
                je      okans1
                sub     si,2
                jmp     rosszx

okans1:         lodsb            ; eddig volt: ESC,[
                cmp     al,'0'
                je      okans1x
                cmp     al,'1'
                je      okans1x
                cmp     al,'3'   ; ha mar a 3x jonnee
                je      hamar3
                sub     si,3
                jmp     rosszx

hamar3:
		mov	bh,ans_hilo
                mov	add_fix,2
                jmp	okans2bel

okans1x:        mov     bh,al    ; eddig volt: ESC,[,0/1
                sub     bh,'0'
                mov	ans_hilo,bh
                lodsb
                cmp     al,';'
                je      okans2
                cmp     al,'m'
                je      hamar4
                sub     si,4
                jmp     rosszx

hamar4:		mov	bl,ans_colo
                mov	add_fix,3
                jmp	okans4bel

okans2:         lodsb
okans2bel:
                cmp     al,'3'
                je      okans3
                sub     si,5
                jmp     rosszx

okans3:         lodsb
                cmp     al,'0'
                jb      norax
                cmp     al,'9'
                ja      norax
                jmp     okans4
norax:
                sub     si,6
                jmp     rosszx

okans4:         mov     bl,al
                sub     bl,'0'
                mov	ans_colo,bl
                lodsb
okans4bel:
                cmp     al,'m'
                je      okans5
                sub     si,7
                jmp     rosszx

okans5:         ; BH-0/1 BL-0..9
                xor     ax,ax
                cmp     bh,1
                jne     abhaz0
                mov     al,10
abhaz0:
                add     al,bl
                mov     bx,ax
                mov     bl,colxcod[bx]

                cmp     dh,0
                jne     ujxxr  ; ha flag-col volt, akkor nincs szinvaltas!
                mov     dl,bl
                jmp     ujxx

ujxxr:          jmp     ujxx

rosszx:         xor	ax,ax
		mov	al,add_fix
		add	si,ax
                lodsb
                ;-------------------------
nocol2:
                stosb
                mov     al,dl
                stosb
                dec     cx
                jmp     ujxx
kiinnen:
                mov dx,ARGcol
                mov ah,dl
                xor al,al
                rep stosw

;-------------------------------------------------
                pop     ds             ;; restore caller registers and return
                pop     di             ;;
                pop     si             ;;
                mov     sp,bp
                pop     bp             ;;
                ret

_colputline     ENDP


_TEXT           ENDS

                END
